import java.util.EventObject ;
import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;

public class DnDDropEvent extends EventObject {
    int dropAction;
    Point dropPoint;
    boolean accepted;
    Transferable dropData;

    public DnDDropEvent(Component source, int action, Point point,
                        Transferable data) {
        super(source);
        dropAction = action;
        dropPoint = point;
        accepted = false;
        dropData = data;
    }

    public Point getLocation() {
        return dropPoint;
    }

    public int getDropAction() {
        return dropAction;
    }

    public boolean isAccepted() {
        return accepted;
    }

    public void acceptDrop() {
        accepted = true;
    }

    public void rejectDrop() {
        accepted = false;
    }

    public Transferable getTransferable() {
        return dropData;
    }
}
