/*
 * @(#)JSVoyagerFileSelection.java	0.1 1999/01/08
 * 
 * Copyright (c) 1999 IS Corp. All Rights Reserved.
 * @author Sergey Izvozchikov
 * 
 */

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.plaf.basic.BasicListCellRenderer;

import java.util.*;
import java.io.IOException;
import java.io.File;
import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;

public class JSVoyagerFileSelection extends Object implements Transferable
{
    Vector files;
    DataFlavor fsFlavor;

    public JSVoyagerFileSelection() {
        files = new Vector();
        fsFlavor = new DataFlavor(files.getClass(), "Selected Files");
    }

    public JSVoyagerFileSelection(JSVoyagerFileSelection ogirinal) {
        files = (Vector) ogirinal.files.clone();
        fsFlavor = ogirinal.fsFlavor;
    }

    public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException
    {
        if ( fsFlavor.equals(flavor) )
            return files;
        else
            return null;
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
        return fsFlavor.equals(flavor);
    }

    public DataFlavor[] getTransferDataFlavors() {
        DataFlavor[] flavors = new DataFlavor[1];
        flavors[0] = fsFlavor;
        return flavors;
    }

    public void addFile(File selectedFile) {
	files.addElement(selectedFile);
    }

    public void clearSelection() {
	files.removeAllElements();
    }

    public File[] getSelectedFiles() {
	int count = files.size();
        File[] filesArray = new File[count];
	for (int i = 0; i < count; i++) {
	    filesArray[i] = (File) files.elementAt(i);
	}
        return filesArray;
    }

    public File getSelectedFile(int index) {
        if (index >= 0 && files.size() > index) {
            return (File) files.elementAt(index);
        }
        return null;
    }

    public boolean isMultipleSelection() {
        return files.size() > 1;
    }

    public int getSelectionSize() {
        return files.size();
    }
}
