/*
 * @(#)JSVoyagerViewer.java	0.1 25/05/99
 * 
 * Copyright (c) 1999 IS Corp. All Rights Reserved.
 * @author Sergey Izvozchikov
 * 
 */

import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.io.*;
import com.sun.java.swing.*;
import com.sun.java.swing.text.*;
import com.sun.java.swing.event.*;

public class JSVoyagerViewer extends JPanel implements HyperlinkListener {
    JSVEditorPane editor;

    public JSVoyagerViewer() {
     	setOpaque(true);
     	setBackground(UIManager.getColor("window"));
	setLayout(new BorderLayout());
      editor = new JSVEditorPane();
      editor.setEditable(false);
      editor.addHyperlinkListener(this);
      JScrollPane scroller = new JScrollPane();
      JViewport vp = scroller.getViewport();
      vp.add(editor);
      add(scroller, BorderLayout.CENTER);
    }

    public void setContent(File file) {
	try {
        if (! file.isDirectory()) {
	    String s = file.getAbsolutePath();
	    s = "file:" + s;
	    URL url = new URL(s);
//          URLConnection conn = url.openConnection();
//          String type = conn.getContentType();
          editor.setPage(url);
        }
	} catch (MalformedURLException e) {
	    System.out.println("Malformed URL: " + e);
	} catch (IOException e) {
	    System.out.println("IOException: " + e);
	}	
    }

    public void hyperlinkUpdate(HyperlinkEvent e) {
	if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
	    linkActivated(e.getURL());
	}
    }

    protected void linkActivated(URL u) {
	Cursor c = editor.getCursor();
	Cursor waitCursor = Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR);
	editor.setCursor(waitCursor);
	SwingUtilities.invokeLater(new PageLoader(u, c));
    }

    class PageLoader implements Runnable {
	
	PageLoader(URL u, Cursor c) {
	    url = u;
	    cursor = c;
	}

        public void run() {
	    if (url == null) {
		// restore the original cursor
		editor.setCursor(cursor);

		// PENDING(prinz) remove this hack when 
		// automatic validation is activated.
		/* Container parent = editor.getParent();
		parent.repaint(); */
	    } else {
		Document doc = editor.getDocument();
		try {
		    editor.setPage(url);
		} catch (IOException ioe) {
		    editor.setDocument(doc);
		    //getToolkit().beep();
		} finally {
		    // schedule the cursor to revert after
		    // the paint has happended.
		    url = null;
		    SwingUtilities.invokeLater(this);
		}
	    }
	}

	URL url;
	Cursor cursor;
    }
}

class JSVEditorPane extends JEditorPane {
    public EditorKit getEditorKitForContentType(String type) {
        System.out.println("Request of EditorKit for type :" + type);
        try {
          EditorKit ek = super.getEditorKitForContentType(type);
          return ek;
        }
        catch (NullPointerException e) {
          return super.createEditorKitForContentType("text/plain");
        }
    }
}
